<?xml version='1.0' encoding='UTF-8'?>
<!--
    Licensed to the Apache Software Foundation (ASF) under one or more
    contributor license agreements.  See the NOTICE file distributed with
    this work for additional information regarding copyright ownership.
    The ASF licenses this file to You under the Apache License, Version 2.0
    (the "License"); you may not use this file except in compliance with
    the License.  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
-->
<beans xmlns="http://www.springframework.org/schema/beans"
       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
       xsi:schemaLocation="http://www.springframework.org/schema/beans
          http://www.springframework.org/schema/beans/spring-beans-3.0.xsd">

    <bean id="esUpdateOersi" class="com.oersi.de.EsUpdateOersi" init-method="init"/>


    <bean id="taskExecutorService" class="com.oersi.de.async.TaskExecutorService" destroy-method="shutdown">
        <constructor-arg value="${bulk.thread.pool.size:20}"
                         name="threadPoolSize"/> <!-- default value of 20 if property not found -->
    </bean>

    <!--    <bean id="nodeRetriever" class="com.oersi.de.node_service.NodeRetriever">-->
    <!--        <property name="nodeService" ref="NodeService"/>-->
    <!--    </bean>-->

    <!--    Events handlers -->

    <bean id="com.oersi.de.behavior.folderEventHandler"
          class="com.oersi.de.behavior.FolderEventHandler"
          init-method="registerEventHandlers">
        <property name="taskExecutorService" ref="taskExecutorService"/>
        <property name="policyComponent" ref="policyComponent"/>
        <property name="policyBehaviourFilter" ref="policyBehaviourFilter"/>
        <property name="serviceRegistry" ref="ServiceRegistry"/>
        <property name="actionService" ref="ActionService"/>
        <property name="nodeService" ref="NodeService"/>
        <property name="eduSharingPermission" ref="eduSharingCustomPermission"/>
        <property name="eduSharingAspects" ref="eduSharingCustomAspects"/>
    </bean>

    <bean id="com.oersi.de.behavior.documentEventHandler"
          class="com.oersi.de.behavior.DocumentEventHandler"
          init-method="registerEventHandlers">
        <property name="taskExecutorService" ref="taskExecutorService"/>
        <property name="policyComponent" ref="policyComponent"/>
        <property name="policyBehaviourFilter" ref="policyBehaviourFilter"/>
        <property name="serviceRegistry" ref="ServiceRegistry"/>
        <property name="actionService" ref="ActionService"/>
        <property name="nodeService" ref="NodeService"/>
        <property name="eduSharingPermission" ref="eduSharingCustomPermission"/>
        <property name="eduSharingAspects" ref="eduSharingCustomAspects"/>
    </bean>
    <!-- action -->

    <bean id="oersi.update.action.UpdateOersiAction" class="com.oersi.de.action.UpdateOersiAction"
          parent="action-executer">
        <property name="oersiService">
            <ref bean="oersiServiceImpl"/>
        </property>
    </bean>

    <!--    custom edu-sharing permission-->
    <bean id="eduSharingCustomPermission" class="com.oersi.de.permission.EduSharingPermission">
        <property name="permissionService">
            <ref bean="PermissionService"/>
        </property>
    </bean>

    <!--    custom edu-sharing permission-->
    <bean id="eduSharingCustomAspects" class="com.oersi.de.permission.EduSharingAspects"/>

    <bean id="oersiServiceImpl" class="com.oersi.de.services.OersiServiceImpl">
        <property name="oersiUrl" value="${oersi.url}"/>
        <property name="eduSharingBaseUrl" value="${edu_sharing.baseUrl}"/>
    </bean>

</beans>
